using Microsoft.Deployment.WindowsInstaller;
using System;
using System.IO;

using TestLibrary;

namespace TestAction
{
    /// <summary>
    /// Ŀ ׼
    /// </summary>
    public class CustomAction
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region  ġ  ׼ ϱ - ExecuteFirstInstallStartAction(session)

        /// <summary>
        ///  ġ  ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteFirstInstallStartAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteFirstInstallStartAction : {ApplicationEnvironment.Version}");

            return ActionResult.Success;
        }

        #endregion
        #region  ġ  ׼ ϱ - ExecuteFirstInstallEndAction(session)

        /// <summary>
        ///  ġ  ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteFirstInstallEndAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteFirstInstallEndAction : {ApplicationEnvironment.Version}");

            #region  񽺸 ϰ Ѵ.

            try
            {
                string directoryPath = session["APPDIR"];
                string filePath      = Path.Combine(directoryPath, ApplicationEnvironment.ServiceFileName);

                logHelper.WriteLog($"SERVICE FILE PATH : {filePath}");

                WindowsServiceHelper.CreateWindowsService(ApplicationEnvironment.ServiceName, filePath);

                logHelper.WriteLog($"SERVICE CREATED : {ApplicationEnvironment.ServiceName}");

                WindowsServiceHelper.StartWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE STARTED : {ApplicationEnvironment.ServiceName}");
            }
            catch(Exception exception)
            {
                logHelper.WriteErrorLog(exception, "ExecuteFirstInstallEndAction Error");
            }

            #endregion

            return ActionResult.Success;
        }

        #endregion

        #region ׷̵ ġ  ׼ ϱ - ExecuteUpgradeInstallStartAction(session)

        /// <summary>
        /// ׷̵ ġ  ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteUpgradeInstallStartAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteUpgradeInstallStartAction : {ApplicationEnvironment.Version}");

            #region  񽺸 ߴϰ Ѵ.

            try
            {
                string directoryPath = session["APPDIR"];
                string filePath      = Path.Combine(directoryPath, ApplicationEnvironment.ServiceFileName);

                logHelper.WriteLog($"SERVICE FILE PATH : {filePath}");

                WindowsServiceHelper.StopWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE STOPPED : {ApplicationEnvironment.ServiceName}");

                WindowsServiceHelper.DeleteWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE DELETED : {ApplicationEnvironment.ServiceName}");
            }
            catch(Exception exception)
            {
                logHelper.WriteErrorLog(exception, "ExecuteUpgradeInstallStartAction Error");
            }

            #endregion

            return ActionResult.Success;
        }

        #endregion
        #region ׷̵ ġ  ׼ ϱ - ExecuteUpgradeInstallEndAction(session)

        /// <summary>
        /// ׷̵ ġ  ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteUpgradeInstallEndAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteUpgradeInstallEndAction : {ApplicationEnvironment.Version}");

            #region  񽺸 ϰ Ѵ.

            try
            {
                string directoryPath = session["APPDIR"];
                string filePath      = Path.Combine(directoryPath, ApplicationEnvironment.ServiceFileName);

                logHelper.WriteLog($"SERVICE FILE PATH : {filePath}");

                WindowsServiceHelper.CreateWindowsService(ApplicationEnvironment.ServiceName, filePath);

                logHelper.WriteLog($"SERVICE CREATED : {ApplicationEnvironment.ServiceName}");

                WindowsServiceHelper.StartWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE STARTED : {ApplicationEnvironment.ServiceName}");
            }
            catch(Exception exception)
            {
                logHelper.WriteErrorLog(exception, "ExecuteFirstInstallEndAction Error");
            }

            #endregion

            return ActionResult.Success;
        }

        #endregion

        #region ġ   ׼ ϱ - ExecuteUninstallStartAction(session)

        /// <summary>
        /// ġ   ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteUninstallStartAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteUninstallStartAction : {ApplicationEnvironment.Version}");

            #region  񽺸 ߴϰ Ѵ.

            try
            {
                string directoryPath = session["APPDIR"];
                string filePath      = Path.Combine(directoryPath, ApplicationEnvironment.ServiceFileName);

                logHelper.WriteLog($"SERVICE FILE PATH : {filePath}");

                WindowsServiceHelper.StopWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE STOPPED : {ApplicationEnvironment.ServiceName}");

                WindowsServiceHelper.DeleteWindowsService(ApplicationEnvironment.ServiceName);

                logHelper.WriteLog($"SERVICE DELETED : {ApplicationEnvironment.ServiceName}");
            }
            catch(Exception exception)
            {
                logHelper.WriteErrorLog(exception, "ExecuteUpgradeInstallStartAction Error");
            }

            #endregion

            return ActionResult.Success;
        }

        #endregion
        #region ġ   ׼ ϱ - ExecuteUninstallEndAction(session)

        /// <summary>
        /// ġ   ׼ ϱ
        /// </summary>
        /// <param name="session"></param>
        /// <returns>׼ </returns>
        [CustomAction]
        public static ActionResult ExecuteUninstallEndAction(Session session)
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            logHelper.WriteLog($"ExecuteUninstallEndAction : {ApplicationEnvironment.Version}");

            return ActionResult.Success;
        }

        #endregion
    }
}