﻿using System;
using System.Windows.Forms;

namespace TestTray
{
    /// <summary>
    /// 구성 폼
    /// </summary>
    public partial class ConfigurationForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 메시지 표시 여부
        /// </summary>
        private bool showMessage = true;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 메시지 표시 여부 - ShowMessage

        /// <summary>
        /// 메시지 표시 여부
        /// </summary>
        public bool ShowMessage
        {
            get
            {
                return this.showMessage;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ConfigurationForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public ConfigurationForm()
        {
            InitializeComponent();

            Activated               += Form_Activated;
            this.applyButton.Click  += applyButton_Click;
            this.cancelButton.Click += cancelButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 활성화시 처리하기 - Form_Activated(sender, e)

        /// <summary>
        /// 폼 활성화시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Activated(object sender, EventArgs e)
        {
            this.showMessageCheckBox.Checked = this.showMessage;
        }

        #endregion
        #region Apply 버튼 클릭시 처리하기 - applyButton_Click(sender, e)

        /// <summary>
        /// Apply 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void applyButton_Click(object sender, EventArgs e)
        {
            this.showMessage = this.showMessageCheckBox.Checked;

            Close();
        }

        #endregion
        #region Cancel 버튼 클릭시 처리하기 - cancelButton_Click(sender, e)

        /// <summary>
        /// Cancel 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void cancelButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        #endregion
    }
}