﻿using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

using TestLibrary;

namespace TestTray
{
    /// <summary>
    /// 프로그램
    /// </summary>
    static class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        [STAThread]
        static void Main()
        {
            ILogHelper logHelper = new FileLogHelper("d:\\", "TestNode.log");

            string directoryPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            string filePath      = Path.Combine(directoryPath, "updater.exe");

            logHelper.WriteLog($"UPDATER DIRECTORY PATH : {directoryPath}");
            logHelper.WriteLog($"UPDATER FILE PATH      : {filePath     }");

            #region 업데이트 여부를 조사하고 필요시 업데이터를 실행한다.

            if(File.Exists(filePath))
            {
                try
                {
                    //Process process = Process.Start(filePath, "/silentall");
                    Process process = Process.Start(filePath);

                    process.WaitForExit();

                    logHelper.WriteLog($"UPDATER PROCESS EXIT CODE : {process.ExitCode}");

                    if(process.ExitCode == 0)
                    {
                        return;
                    }
                }
                catch
                {
                }
            }
            else
            {
                logHelper.WriteLog($"UPDATER FILE NOT FOUND : {filePath}");
            }

            #endregion

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new MainApplicationContext());
        }

        #endregion
    }
}